package de.thpeetz.kontor.comics.views;

import java.util.List;

import com.vaadin.flow.component.ComponentEvent;
import com.vaadin.flow.component.ComponentEventListener;
import com.vaadin.flow.component.Key;
import com.vaadin.flow.component.button.Button;
import com.vaadin.flow.component.button.ButtonVariant;
import com.vaadin.flow.component.combobox.ComboBox;
import com.vaadin.flow.component.formlayout.FormLayout;
import com.vaadin.flow.component.orderedlayout.HorizontalLayout;
import com.vaadin.flow.component.textfield.TextField;
import com.vaadin.flow.data.binder.BeanValidationBinder;
import com.vaadin.flow.data.binder.Binder;

import de.thpeetz.kontor.comics.data.Comic;
import de.thpeetz.kontor.comics.data.TradePaperback;

public class TradePaperBackForm extends FormLayout {
    TextField name = new TextField("Name");
    ComboBox<Comic> comic = new ComboBox<>("Comic");
    TextField issueStart = new TextField("Issue Start");
    TextField issueEnd = new TextField("Issue End");

    Button save = new Button("Save");
    Button delete = new Button("Delete");
    Button close = new Button("Cancel");

    Binder<TradePaperback> binder = new BeanValidationBinder<>(TradePaperback.class);

    public TradePaperBackForm(List<Comic> comics) {
        addClassName("tradepaperback-form");
        binder.bindInstanceFields(this);

        comic.setItems(comics);
        comic.setItemLabelGenerator(Comic::getTitle);
        add(name, comic, issueStart, issueEnd, createButtonsLayout());
    }

    private HorizontalLayout createButtonsLayout() {
        save.addThemeVariants(ButtonVariant.LUMO_PRIMARY);
        delete.addThemeVariants(ButtonVariant.LUMO_ERROR);
        close.addThemeVariants(ButtonVariant.LUMO_TERTIARY);

        save.addClickShortcut(Key.ENTER);
        close.addClickShortcut(Key.ESCAPE);

        save.addClickListener(event -> validateAndSave());
        delete.addClickListener(event -> fireEvent(new DeleteEvent(this, binder.getBean())));
        close.addClickListener(event -> fireEvent(new CloseEvent(this)));

        binder.addStatusChangeListener(e -> save.setEnabled(binder.isValid()));
        return new HorizontalLayout(save, delete, close);
    }

    private void validateAndSave() {
        if (binder.isValid()) {
            fireEvent(new SaveEvent(this, binder.getBean()));
        }
    }

    public void setTradePaperBack(TradePaperback tradepaperback) {
        binder.setBean(tradepaperback);
    }

    public abstract static class TradePaperBackFormEvent extends ComponentEvent<TradePaperBackForm> {
        private TradePaperback tradepaperback;

        protected TradePaperBackFormEvent(TradePaperBackForm source, TradePaperback tradepaperback) {
            super(source, false);
            this.tradepaperback = tradepaperback;
        }

        public TradePaperback getTradePaperBack() {
            return tradepaperback;
        }
    }

    public static class SaveEvent extends TradePaperBackFormEvent {
        SaveEvent(TradePaperBackForm source, TradePaperback tradepaperback) {
            super(source, tradepaperback);
        }
    }

    public static class DeleteEvent extends TradePaperBackFormEvent {
        DeleteEvent(TradePaperBackForm source, TradePaperback tradepaperback) {
            super(source, tradepaperback);
        }
    }

    public static class CloseEvent extends TradePaperBackFormEvent {
        CloseEvent(TradePaperBackForm source) {
            super(source, null);
        }
    }

    public void addDeleteListener(ComponentEventListener<DeleteEvent> listener) {
        addListener(DeleteEvent.class, listener);
    }

    public void addSaveListener(ComponentEventListener<SaveEvent> listener) {
        addListener(SaveEvent.class, listener);
    }

    public void addCloseListener(ComponentEventListener<CloseEvent> listener) {
        addListener(CloseEvent.class, listener);
    }
}
